; ******************************************************************
;                          CL.LSP

;    By Simon Jones    Autodesk Ltd , London      March 1987

;  Dieses Macro erzeugt zwei sich kreuzende Linien im Mittelpunkt
;  eines Kreises. Die Linien befinden sich auf dem Layer "CL".
;  (gendert auf LinienTyp Strichpunkt im Layer HILF)
;  Pietr. 10.05.90, Anpassung an WINNT 2.5.96 / 25.8.00
; ******************************************************************

(defun clerr (s)
   (if (/= s "Function Cancelled")    ; Wenn ein Fehler (z.B.CTRL-C)
      (princ (strcat "\nFehler: " s)) ; auftritt waehrend der Befehl
                                      ; aktiv ist...
   )
 ;  (command "BKS" "V")               ; altes BKS holen
   (setvar "BLIPMODE" sblip)         ; alte Modi holen
   (setvar "GRIDMODE" sgrid)
   (setvar "HIGHLIGHT" shl)
   (setvar "UCSFOLLOW" sucsf)
   (command "LAYER" "S" clay "")
   (command "zurck" "e")
   (setvar "CMDECHO" scmde)
   (setq *error* olderr)             ; alte Fehlerroutine holen
   (princ)
)

(defun C:CL (/ olderr clay sblip scmde sgrid shl sucsf e cen rad d ts xx)
   (setq olderr  *error*
         *error* clerr)
   (setq scmde (getvar "CMDECHO"))
   (command "zurck" "gruppe")
   (setq clay  (getvar "CLAYER"))
   (setq sblip (getvar "BLIPMODE"))
   (setq sgrid (getvar "GRIDMODE"))
   (setq shl   (getvar "HIGHLIGHT"))
   (setq sucsf (getvar "UCSFOLLOW"))
   (setvar "CMDECHO" 0)
   (setvar "GRIDMODE" 0)
   (setvar "UCSFOLLOW" 0)
   (setq e nil xx "Ja")
   (setq ts (tblsearch "LAYER" "HILF"))
   (if (null ts)
       (prompt "\nErstelle neuen Layer - HILF. ")
       (progn
        (if (= (logand 1 (cdr (assoc 70 ts))) 1)
            (progn
             (prompt "\nLayer HILF ist gefroren. ")
             (initget  "Ja Nein")
             (setq xx (getkword "\nWeiterfahren? <N>: "))
             (if (= xx "Ja")
                 (command "LAYER" "Tau" "HILF" "")
             )
            )
        )
       )
   )

   (if (= xx "Ja")
      (progn
       (while (null e)
          (setq e (entsel "\nBogen oder Kreis waehlen: "))
          (if e
              (progn
               (setq e (car e))
               (if (and
                     (/= (cdr (assoc 0 (entget e))) "ARC")
                     (/= (cdr (assoc 0 (entget e))) "CIRCLE")
                   )
                   (progn (prompt "\nElement ist ein")
                          (princ (cdr (assoc 0 (entget e))))
                          (setq e nil)
                   )
               )
              )
          )
       )
       (setq uc (getvar "UCSNAME")) 
       (command "BKS" "_e" e)
       (setq cen (trans (cdr (assoc 10 (entget e))) e 1))
       (print cen)
       (setq rad (cdr (assoc 40 (entget e))))
       (prompt "\nRadius ist ")
       (princ (rtos rad))
       (initget 7 "Laenge")
       (setq d (getdist "\nLaenge/<Ueberstand>: "))
       (if (= d "Laenge")
        (progn
         (initget 7)
         (setq d (getdist cen "\nLaenge: "))
        )
        (setq d (+ rad d))
       )
       (setvar "BLIPMODE" 0)
       (setvar "HIGHLIGHT" 0)
       (command "LAYER" "Mach" "HILF" "Farbe" "4" "" "LT" "STRICHPUNKT2" "" "")

       (command "LINIE" (list (car cen) (+ (cadr cen) d) (caddr cen))
                        (list (car cen)  (cadr cen)  (caddr cen))
                        ""
       )

       (command "NDERN" "l" "" "EIG" "Layer" "HILF" "")

       (command "Reihe" "l" "" "p" (list (car cen)(cadr cen)) "4" "" "")

       (command "LAYER" "SE" clay "")
      )
   )
   (command "BKS" uc)               ; altes BKS holen
   (setvar "BLIPMODE" sblip)         ; alte Modi holen
   (setvar "GRIDMODE" sgrid)
   (setvar "HIGHLIGHT" shl)
   (setvar "UCSFOLLOW" sucsf)
   (command "zurck" "e")
   (setvar "CMDECHO" scmde)
   (setq *error* olderr)             ; alte Fehlerroutine holen
   (princ)
)
